<!DOCTYPE html>
<html lang="en">
<head>
<meta name="viewport"
	content="width=device-width, initial-scale=1, shrink-to-fit=no">
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<title>HyperHTML Examples</title>

<!-- Bootstrap import -->
<link rel="stylesheet" href="resources/css/oreillybs-4.0.0r1.min.css" />

<!-- Project CSS import -->
<link type="text/css" href="resources/css/master.css" rel="stylesheet" />

<!-- O'Reilly hyperHTML JS -->
<script src="resources/js/oreillyjs/1/orly.js"></script>

<!-- Hyper JS -->
<!-- There is not need for this library since we have our own hyperHTML library (above) -->
<!-- <script src="https://unpkg.com/hyperhtml@latest/min.js"></script> -->

<style>
body {
	padding: 5px 5px;
}

code, pre {
	background-color: #fff;
}

.hidden {
	display: hidden;
}
</style>
</head>
<body>
	<div id="bodyContentTile" class="container-fluid">
		<div class="content">
			<div class="container">
				<div class="row hidden" id="success-container">
					<div class="col-12">
						<orly-alert-mgr id="alerts"></orly-alert-mgr>
					</div>
				</div>
				<div class="row">
					<div class="col-12">
						<h1>Internship Manager</h1>
					</div>
				</div>
				<div id="internTableDiv" class="row">
					<div class="col-12">
						<div id="internTable" class="">
							<button id="addInternBtn" class="btn btn-primary mb-1">Add
								Intern</button>
							<table class="table table-bordered">
								<thead>
									<tr>
										<th scope="col">Action</th>
										<th scope="col">ID</th>
										<th scope="col">First Name</th>
										<th scope="col">Last Name</th>
										<th scope="col">Age</th>
										<th scope="col">Start Date</th>
										<th scope="col">Graduation Date</th>
									</tr>
								</thead>
								<tbody id="tbody">
								</tbody>
							</table>
						</div>
						Intern Manager Table Goes Here
						<!-- Build table here -->


						<div>
							<orly-icon color="wheat" name='edit'></orly-icon>
							<orly-icon color="red" name='x'></orly-icon>
						</div>

						<div>Icon Examples for the Action Column:</div>
					</div>
				</div>
				<div id="addEditInternDiv" class="row d-none">
					<div class="col-12">
						<form name="internForm">
							<div class="form-group">
								<label for="teamMemberNumber">Team Member Number</label> <input
									type="text" class="form-control" id="teamMemberNumber" disabled>
							</div>
							<div class="form-group">
								<label for="firstName">First Name</label> <input type="text"
									class="form-control" id="firstName" placeholder="First name"
									required name="firstName">
							</div>
							<div class="form-group">
								<label for="lastName">Last Name</label> <input type="text"
									class="form-control" id="lastName" placeholder="last Name"
									name="lastName">
							</div>
							<div class="form-group">
								<label for="age">Age</label> <input type="text"
									class="form-control" id="formAge" placeholder="Age" name="age">
							</div>
							<div class="form-group">
								<label for="startDate">Start Date</label> <input type="text"
									class="form-control" id="startDate" placeholder="Start date"
									name='startDate'>
							</div>
							<div class="form-group">
								<label for="startDate">Graduation Date</label> <input
									type="text" class="form-control" id="graduationDate"
									placeholder="Graduation date" name="graduationDate">
							</div>
						</form>

						<p>
							<orly-btn id="submitBtn" backdrop="false" size="sm" text="Submit"></orly-btn>
						</p>
					</div>
				</div>
			</div>
		</div>
	</div>
	<script>
		/* *********************************
		 * Declare Global Variables
		 ***********************************/
		var internsArray = [];
		var submitBtn;
		var addInternBtn;
		var internTableDiv;
		var addEditInternDiv;
		var internId = 400000;
		var tbody;

		
		// DOM ready
		orly.ready.then(function() {
			// Initialize global variables
			submitBtn = orly.qid("submitBtn");
		    addInternBtn = orly.qid("addInternBtn");
			internTableDiv = orly.qid("internTableDiv");
			addEditInternDiv = orly.qid("addEditInternDiv");
			tbody = document.getElementById("tbody");
			
			// Your table and your Add Intern divs are both showing.
			// You need to update the function "showAndHideElements"!!!
			global.showAndHideElements(internTableDiv, addEditInternDiv);
			
			global.displayInterns(internsArray);
			
			// Populate form  and team member number
			global.populateForm(teamMemberNumber)
 		
			// The DOM is loaded so now we can create Event Listeners
			handleButtonClicks();
			
			// Welcome message
			orly.qid("alerts").createAlert({type:"success", duration:"2000", msg:"Welcome to Intern Manager v0.001"});
			
			// Test access to the global object. (You can delete this call and 
			// the hello function)
			global.hello();
		});	
		
		/* *********************************
		 * Global Namespace For Functions
		 ***********************************/



		var global = {		
			
			hello : function() {
				console.log("hello world!");
			},
				
				
			/**
			  * Display Interns 
			  */
			displayInterns : function() {
				console.log("Display Interns Called");
				this.buildAndDisplayInternTable();
				
			}, // end of displayInterns
			
			getTableData : function(tableData) {
				var td = document.createElement("td");
				var textNode = document.createTextNode(tableData);
				td.appendChild(textNode);
				return td;
			},
			
			getTableImages : function(id) {
				var td = document.createElement("td");
				var editIcon = document.createElement("orly-icon");				
				editIcon.setAttribute("color", "wheat");
				editIcon.setAttribute("name", "edit");
				editIcon.setAttribute("id", "e_" + id)
				
				var deleteIcon = document.createElement("orly-icon");
				deleteIcon.setAttribute("color", "red");
				deleteIcon.setAttribute("name", "x");
				deleteIcon.setAttribute("id", "d_" + id);

				td.appendChild(editIcon);
				td.appendChild(deleteIcon);

				return td;
				/* <orly-icon color="wheat" name='edit'></orly-icon>
				<orly-icon color="red" name='x'></orly-icon> */
			},
			
			/**
			  * Build and display Intern Table 
			  */
			buildAndDisplayInternTable : function() {
				// If the internsArray is empty: 
				// 	   show an empty row that spans all columns
				//     the row should read "No Data Found"
					tbody.innerHTML = "";
					
				if(internsArray.length == 0) {
					let tr = document.createElement("tr");
					let td = document.createElement("td");
					let text = document.createTextNode("No records found.");
					td.setAttribute("colspan", "7");
					td.appendChild(text);
					tr.appendChild(td);
					tbody.appendChild(tr);
					
				} else {
					console.log('we have an intern!')
				    internsArray.forEach(intern => {
						let tr = document.createElement("tr");
						tr.appendChild(this.getTableImages(intern.id));
						tr.appendChild(this.getTableData(intern.id));
						tr.appendChild(this.getTableData(intern.firstName));
						tr.appendChild(this.getTableData(intern.lastName));
						tr.appendChild(this.getTableData(intern.age));
						tr.appendChild(this.getTableData(intern.startDate));
						tr.appendChild(this.getTableData(intern.graduationDate));
						tbody.appendChild(tr);
					});

				}
				
				// If the internsArray is not empty:
				// Sort the interns (by first and/or last name)
			    // Delete the existing table
			    // Build a new table
			    
				console.log("buildAndDisplayInternTable called.");
				this.buildInternTable();
				
			}, // end of buildAndDisplayInternTable
			
			
			/**
			  * Build Intern Table 
			  */
			buildInternTable : function() {
				// Loop through interns
				
				// Build a row for each intern using DOM manipulation
				// (createElement and createTextNode)
				let intern = null;
				this.addTableRow(intern);
				
			}, // end of buildInternTable
			
			
			/**
			  * Add Table Row 
			  */
			addTableRow : function(intern) {
				// Add table row for a given intern 
				
				
			}, // end of addTableRow
			
			
			/**
			  * Show and Hide Elements 
			  */
			showAndHideElements : function(show, hide) {
				// TODO: Hide the element "hide" and show the element "show"
				hide.classList.add("d-none");
				hide.classList.remove("d-block");
				hide.classList.remove("d-inline");
	
				show.classList.add("d-block");
				show.classList.remove("d-none");
			}, // end of showAndHideElements  
			
			
			/**
			  * Add Intern - Called when submitting the "Add New Intern" Form
			  */
			addIntern: function(firstName, lastName, age, startDate, graduationDate) {
				// Generate Intern Id
				let internId = this.getInternId();
				
				// Build Intern
				let intern = {};
				intern.id = internId;
				intern.firstName = orly.qid("firstName").value;
				intern.teamMemberNumber = orly.qid("teamMemberNumber").value;
				intern.lastName = orly.qid("lastName").value;
				intern.age = orly.qid("formAge").value;
				intern.startDate = orly.qid("startDate").value;
				intern.graduationDate = orly.qid("graduationDate").value;


				// Add intern to internsArray
				internsArray.push(intern);
				// Return Intern?
				return intern;
				
			}, // end of addIntern
			
			
			/**
			  * Get Intern Id
			  */
			getInternId: function() {
				return internId++;
				
			}, // end of getInternId
			
			
			/**
			  * Edit Intern - Called after editing an intern 
			  */
			editIntern: function(id, firstName, lastName, age, startDate, graduationDate) {
				// Update the intern in the internsArray
				
			}, // end of editIntern
			
			
			/**
			  * Delete Intern 
			  */
			deleteIntern: function(intern) {
				// Delete the intern from the internsArray
				// Update the table
				
                 /* 
				 var deletedItem = this.internsArray.filter(index => index.internId !== intern.internId);
                 return deletedItem;*/
			
				
			}, // end of deleteIntern

			
			/**
			  * Display Success Message 
			  */
			displaySuccess: function(message) {
			
			}, // end of displaySuccess
			
			
			/**
			  * Display Error Message 
			  */
			displayError: function(message) {
				
			}, // end of displayError
			
			
			/**
			  * Find Intern By Key
			  */
			findInternById: function(searchKey, searchText) {
				// Loop through interns
				// Find the intern using the key (id, firstName, lastName...) and value (searchText)
				// If found, show the table with one or more entries
				// If not found, show "no results"
				
			}, // end of findInternById 
			
			populateForm: function(teamMemberNumber) {
			for(let i=0; i < internsArray.length; i++) {
				if(internsArray[i] == teamMemberNumber) {
					// return intern?
				} else if (teamMemberNumber == null || ""){
					return "please enter a number"
					
				} else  {
					return "user not found?"
				}
			  } 
			}, 
			
			validateForm : function()  {
				  var fn = document.forms["internForm"]["firstName"].value;
				  var ln = document.forms["internForm"]["lastName"].value;
				  var age = document.forms["internForm"]["age"].value;
				  var sd = document.forms["internForm"]["startDate"].value;
				  var gd = document.forms["internForm"]["graduationDate"].value;


				  if (fn == "") {
				    alert("Name must be filled out");
				    return false;
				  }
				  if (ln == "") {
					  alert("last name must be filled out");
					  return false;
				  }
				  if (age < 18) {
					  alert("you must be at least 18 to sign up!");
					  return false;
				  }
				  if (sd == "") {
					  alert("Please enter start! date!");
					  return false;
				  }
				  if (gd == "") {
					  alert("pleae enter grad date!");
					  return false;
				  }
				  return true;
				}
			 
			 
		}; // end of global
		
		// Global functions
			function handleButtonClicks() {
				orly.on(submitBtn, "click", (e)=> {
				if(global.validateForm()) {
					global.addIntern();
					global.showAndHideElements(internTableDiv, addEditInternDiv);
					global.buildAndDisplayInternTable();
					global.deleteIntern();
					console.log(internsArray);
	
				} else {
					alert("fix this!");
				} 
				
			});
			
			orly.on(addInternBtn, "click", (e)=> {
				global.showAndHideElements(addEditInternDiv, internTableDiv);

			});
			
			orly.on(tbody, "click", (e)=> {
				let id = e.target.id;
				alert(id);
				
				//get first character to determine if edit or delete
				let firstLetter = id.substring(0,1);
				let internId = id.substring(2);
				
				//if edit build new global function called showEditForm
				if(firstLetter == "e") {
					//loop through array to find the intern and then call editIntern
			
					//pass the id to the edit internform


					console.log("hotdog");
				} else if(firstLetter = "d") {
					//delete and re build the table
					 var deletedItem = internsArray.filter(index => index.internId !== internId);
					 prompt("are you sure you want to delete");
					 console.log(deletedItem);
	                 return deletedItem;
				} else {
					return "broken!";
				}
				
				// re build the table
				global.displayInterns();
				
			});
	

		}
		
		
	</script>
</body>
</html>